# Cloud Spanner Client - Class BatchSnapshot (2.9.0)

2.9.0 (latest) 2.8.1 2.7.0 2.6.1 2.5.1 2.4.1 2.3.0 2.2.0 2.1.0 2.0.1-RC1 1.106.0 1.105.1 1.104.1 1.103.0 1.102.0 1.101.0 1.100.0 1.98.0 1.97.0 1.96.0 1.95.0 1.94.0 1.93.1 1.92.1 1.91.0 1.90.0 1.89.0 1.88.0 1.87.0 1.86.0 1.85.0 1.84.0 1.83.0 1.82.0 1.81.0 1.80.0 1.79.0 1.78.0 1.77.0 1.76.1 1.68.0 1.67.0 1.66.0 1.65.0 1.64.0 1.63.2 1.62.1 1.61.0 1.60.0 1.59.0 1.58.4 1.57.0 1.56.0 1.55.0 1.54.2 Reference documentation and code samples for the Cloud Spanner Client class BatchSnapshot.

Represents a Read-Only Batch Transaction in Cloud Spanner.

Batch Snapshots can be shared with other servers or processes by casting the
object to a string, or by calling [BatchSnapshot::serialize()](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Batch.BatchSnapshot#_Google_Cloud_Spanner_Batch_BatchSnapshot__serialize__).

Example:

    use Google\Cloud\Spanner\SpannerClient;

    $spanner = new SpannerClient(['projectId' => 'my-project']);
    $batch = $spanner->batch('instance-id', 'database-id');
    $snapshot = $batch->snapshot();

    // Serialize a snapshot to share it with another worker.
    $snapshotString = (string) $snapshot;

    // Calling BatchSnapshot::serialize() has the same effect.
    $snapshotString = $snapshot->serialize();

## Namespace

Google \\ Cloud \\ Spanner \\ Batch

## Methods

### __construct

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `operation` | `Google\Cloud\Spanner\Operation` The Operation instance. |
| `session` | `Google\Cloud\Spanner\Session\SessionCache` The session to use for spanner interactions. |
| `options` | `array` Configuration Options. |
| `↳ id` | `string` The Transaction ID. |
| `↳ readTimestamp` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Timestamp` The read timestamp. |

### partitionRead

Begin a partitioned read.

Example:

    use Google\Cloud\Spanner\KeySet;

    $keySet = new KeySet(['all' => true]);
    $columns = ['id', 'firstName', 'lastName'];
    $partitions = $snapshot->partitionRead('Users', $keySet, $columns);

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `table` | `string` The table name. |
| `keySet` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/KeySet` The KeySet to select rows. |
| `columns` | `string[]` A list of column names to return. |
| `options` | `array` Configuration Options |
| `↳ maxPartitions` | `int` The desired maximum number of partitions to return. For example, this may be set to the number of workers available. The maximum value is currently 200,000. This is only a hint. The actual number of partitions returned may not always match the requested value. **Defaults to** `10000`. |
| `↳ partitionSizeBytes` | `int` The desired data size for each partition generated. This is only a hint. The actual size of each partition may be smaller or larger than this size request. **Defaults to** `1000000000` (i.e. 1 GiB). |
| `↳ index` | `string` The name of an index on the table. |
| `↳ dataBoostEnabled` | `bool` This is an optional parameter which can be used for partition read and query to execute the request via spanner independent compute resources. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `array<https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Batch.ReadPartition>` |   |

### partitionQuery

Begin a partitioned SQL query.

Example:

    use Google\Cloud\Spanner\Timestamp;

    $queryString = 'SELECT * FROM Users WHERE joinDate < @joinDate AND lastLogin > @loginCutoff';
    $partitions = $snapshot->partitionQuery($queryString, [
        'parameters' => [
            'joinDate' => new Timestamp(new \DateTime('2017-01-01')),
            'loginDate' => new Timestamp(new \DateTime('2017-12-31'))
        ]
    ]);

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `sql` | `string` The query string to execute. |
| `options` | `array` Configuration Options |
| `↳ maxPartitions` | `int` The desired maximum number of partitions to return. For example, this may be set to the number of workers available. The maximum value is currently 200,000. This is only a hint. The actual number of partitions returned may not always match the requested value. **Defaults to** `10000`. |
| `↳ partitionSizeBytes` | `int` The desired data size for each partition generated. This is only a hint. The actual size of each partition may be smaller or larger than this size request. **Defaults to** `1000000000` (i.e. 1 GiB). |
| `↳ parameters` | `array` A key/value array of Query Parameters, where the key is represented in the query string prefixed by a `@` symbol. |
| `↳ types` | `array` A key/value array of Query Parameter types. Generally, Google Cloud PHP can infer types. Explicit type definitions are only necessary for null parameter values. Accepted values are defined as constants on [Google\\Cloud\\Spanner\\ValueMapper](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/ValueMapper), and are as follows: `Database::TYPE_BOOL`, `Database::TYPE_INT64`, `Database::TYPE_FLOAT64`, `Database::TYPE_TIMESTAMP`, `Database::TYPE_DATE`, `Database::TYPE_STRING`, `Database::TYPE_BYTES`, `Database::TYPE_ARRAY` and `Database::TYPE_STRUCT`. If the parameter type is an array, the type should be given as an array, where the first element is `Database::TYPE_ARRAY` and the second element is the array type, for instance `[Database::TYPE_ARRAY, Database::TYPE_INT64]`. |
| `↳ dataBoostEnabled` | `bool` This is an optional parameter which can be used for partition read and query to execute the request via spanner independent compute resources. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `array<https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Batch.QueryPartition>` |   |

### executePartition

Read rows from a partition.

Partitions are created by calling [BatchSnapshot::partitionRead()](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Batch.BatchSnapshot#_Google_Cloud_Spanner_Batch_BatchSnapshot__partitionRead__)
or [BatchSnapshot::partitionQuery()](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Batch.BatchSnapshot#_Google_Cloud_Spanner_Batch_BatchSnapshot__partitionQuery__).
Generally, those partitions will be distributed to worker processes, each
of which will call this method with the partition it was given.

Example:

    $result = $snapshot->executePartition($partition);

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `partition` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Batch.PartitionInterface` The partition to read. |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/Result` |   |

### serialize

Return a stringified representation of the BatchSnapshot object.

Example:

    $snapshotString = $snapshot->serialize();

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |

### __toString

Cast the snapshot to a string.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |